Summary: Distributed reliable key-value store for the most critical data of a distributed system
Name: etcd
Version: 3.3.2
Release: 1
License: ASL 2.0
URL: https://etcd.readthedocs.io/en/latest

# https://github.com/coreos/etcd/releases/download/v3.3.2/v3.3.2.tar.gz
# Run glide install --strip-vendor
Source: etcd-3.3.2+vendor.tar.gz
Patch: etcd-3.3.2-aix.patch

Group: Applications/System

BuildRequires: gcc-go >= 8.1.0

Requires: libgo >= 8.1.0-2
Requires: libgcc >= 8.1.0-2

%description
etcd is a distributed reliable key-value store for the most
critical data of a distributed system.

%package -n etcdctl
Summary: Command-line client for etcd.

%description -n etcdctl
Command-line client for etcd.

%prep

%setup -q

%patch -p1 -b .aix

%build
export PATH=/usr/bin:/etc:/usr/sbin:/sbin:/opt/freeware/bin

mkdir -p ./_root
mkdir -p ./_build/src/github.com/coreos
ln -s $(pwd) ./_build/src/github.com/coreos/etcd

export GOPATH=$(pwd)/_build
export GOARCH=ppc64
export CGO_ENABLED=1
export GOROOT=$(pwd)/_root

ulimit -d unlimited
ulimit -m unlimited
ulimit -s unlimited
ulimit -f unlimited

# etcd
go build -v -p=3 -gccgoflags='all=-mcmodel=large' -o dist/etcd github.com/coreos/etcd

# etcdctl
go build -v -p=3 -gccgoflags='all=-mcmodel=large' -o dist/etcdctl github.com/coreos/etcd/etcdctl

%install
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
strip -X64 -t dist/etcd
/usr/bin/install -M 0755 -f ${RPM_BUILD_ROOT}%{_bindir} dist/etcd
strip -X64 -t dist/etcdctl
/usr/bin/install -M 0755 -f ${RPM_BUILD_ROOT}%{_bindir} dist/etcdctl

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%doc LICENSE NOTICE
%{_bindir}/etcd

%files -n etcdctl
%doc LICENSE NOTICE
%{_bindir}/etcdctl

%changelog
* Mon Aug 27 2018 Damien Bergamini - 3.3.2-1
- Initial port of etcd 3.3.2 to AIX
